#!/usr/bin/perl
# edit_profile.cgi
# Edit or create a burn profile

require './burner-lib.pl';
&ReadParse();

if ($in{'type'}) {
	&header($text{'create_title'}, "");
	$profile = { 'type' => $in{'type'} };
	}
else {
	&header($text{'edit_title'}, "");
	$profile = &get_profile($in{'id'});
	}
print "<hr>\n";

if ($profile->{'type'} == 2 && !&has_command($config{'mkisofs'})) {
	print "<p>",&text('edit_emkisofs', "<tt>$config{'mkisofs'}</tt>",
			  "/config.cgi?$module_name"),"<p>\n";
	print "<hr>\n";
	&footer("", $text{"index_return"});
	exit;
	}
if ($profile->{'type'} == 3 && !&has_command($config{'mpg123'})) {
	print "<p>",&text('edit_empg123', "<tt>$config{'mpg123'}</tt>",
			  "/config.cgi?$module_name"),"<p>\n";
	print "<hr>\n";
	&footer("", $text{"index_return"});
	exit;
	}

print "<form action=save_profile.cgi>\n";
print "<input type=hidden name=id value='$in{'id'}'>\n";
print "<input type=hidden name=type value='$in{'type'}'>\n";

print "<table border width=100%>\n";
print "<tr $tb> <td><b>$text{'edit_header'}</b></td> </tr>\n";
print "<tr $cb> <td><table width=100%>\n";

print "<tr> <td><b>$text{'edit_name'}</b></td>\n";
print "<td><input name=name size=25 value='$profile->{'name'}'></td>\n";
print "<td colspan=2></td> </tr>\n";

if ($profile->{'type'} == 1) {
	# Single ISO options
	print "<tr> <td><b>$text{'edit_iso'}</b></td>\n";
	printf "<td colspan=3><input name=iso size=45 value='%s'> %s</td>\n",
		$profile->{'iso'}, &file_chooser_button("iso");
	print "</tr>\n";

	print "<tr> <td><b>$text{'edit_isosize'}</b></td>\n";
	printf "<td><input type=radio name=isosize value=1 %s> %s\n",
		$profile->{'isosize'} ? 'checked' : '', $text{'yes'};
	printf "<input type=radio name=isosize value=0 %s> %s</td> </tr>\n",
		$profile->{'isosize'} ? '' : 'checked', $text{'no'};
	}
elsif ($profile->{'type'} == 2) {
	# Multi-directory options
	print "<tr> <td valign=top><b>$text{'edit_dirs'}</b></td>\n";
	print "<td colspan=3><table width=100% border=1>\n";
	print "<tr $tb> <td><b>$text{'edit_source'}</b></td> ",
	      "<td><b>$text{'edit_dest'}</b></td> </tr>\n";
	for($i=0; $profile->{"source_".($i-4)} || $i < 4; $i++) {
		print "<tr $cb>\n";
		printf "<td><input name=source_%d size=35 value='%s'>%s</td>\n",
			$i, $profile->{"source_$i"}, 
			&file_chooser_button("source_$i");
		printf "<td><input name=dest_%d size=25 value='%s'></td>\n",
			$i, $profile->{"dest_$i"} ? $profile->{"dest_$i"} : "/";
		print "</tr>\n";
		}
	print "</table>\n";

	print "<tr> <td><b>$text{'edit_rock'}</b></td>\n";
	printf "<td colspan=3><input type=radio name=rock value=2 %s> %s\n",
		$profile->{'rock'} == 2 ? 'checked' : '', $text{'edit_rock2'};
	printf "<input type=radio name=rock value=1 %s> %s\n",
		$profile->{'rock'} == 1 ? 'checked' : '', $text{'yes'};
	printf "<input type=radio name=rock value=0 %s> %s</td> </tr>\n",
		$profile->{'rock'} == 0 ? 'checked' : '', $text{'no'};

	print "<tr> <td><b>$text{'edit_joliet'}</b></td>\n";
	printf "<td><input type=radio name=joliet value=1 %s> %s\n",
		$profile->{'joliet'} ? 'checked' : '', $text{'yes'};
	printf "<input type=radio name=joliet value=0 %s> %s</td>\n",
		$profile->{'joliet'} ? '' : 'checked', $text{'no'};

	print "<td><b>$text{'edit_long'}</b></td>\n";
	printf "<td><input type=radio name=long value=1 %s> %s\n",
		$profile->{'long'} ? 'checked' : '', $text{'yes'};
	printf "<input type=radio name=long value=0 %s> %s</td> </tr>\n",
		$profile->{'long'} ? '' : 'checked', $text{'no'};

	print "<tr> <td><b>$text{'edit_trans'}</b></td>\n";
	printf "<td><input type=radio name=trans value=1 %s> %s\n",
		$profile->{'trans'} ? 'checked' : '', $text{'yes'};
	printf "<input type=radio name=trans value=0 %s> %s</td>\n",
		$profile->{'trans'} ? '' : 'checked', $text{'no'};

	print "<td><b>$text{'edit_volid'}</b></td>\n";
	printf "<td><input name=volid size=15 value='%s'></td> </tr>\n",
		$profile->{'volid'};
	}
else {
	# MP3 files or directories of them
	print "<tr> <td valign=top><b>$text{'edit_mp3s'}</b></td>\n";
	print "<td colspan=3>\n";
	for($i=0; $profile->{"source_".($i-4)} || $i < 4; $i++) {
		printf "<input name=source_%d size=50 value='%s'> %s<br>\n",
			$i, $profile->{"source_$i"},
			&file_chooser_button("source_$i");
		}
	print "</td> </tr>\n";
	}

print "</table></td></tr></table><br>\n";
print "<table width=100%><tr>\n";
print "<td width=25%><input type=submit value='$text{'save'}'></td>\n";
print "<td width=25% align=center><input type=submit name=burn ",
      "value='$text{'edit_burn'}'></td>\n";
print "<td width=25% align=center><input type=submit name=test ",
      "value='$text{'edit_test'}'></td>\n";
if ($profile->{'id'}) {
	print "<td width=25% align=right><input type=submit name=delete ",
	      "value='$text{'delete'}'></td>\n";
	}
else {
	print "<td width=25%></td>\n";
	}
print "</tr></table></form>\n";

print "<hr>\n";
&footer("", $text{'index_return'});

